/** Classe représentant les données à stoquer: des paires (String, int) */
public class Data implements Comparable<Data> {

	/** étiquette de la donnée */
	String s;
	/** valeur de la donnée */
	int val;

	static int cnt = 0;

	Data(String s, int val) {
		this.s=s;
		this.val=val;
	}

	/** Compare deux données, par rapport à 'val' */
	public int compareTo(Data d) {
		cnt++;
		if(this.val>d.val) return 1;
		else if(this.val<d.val) return -1;
		return 0;
	}

	/** Renvoie l'élément ayant valeur minimale entre d1 et d2 */
	static Data min(Data d1, Data d2) {
		if(d1.compareTo(d2)<=0)
			return d1;
		else
			return d2;
	}

	/** Teste si deux éléments sont égaux: ils ont la même étiquette 's' */
	public boolean equals(Object o) {
		Data d=(Data)o;
		return this.s.equals(d.s);
	}

	/** Fonction d'hachage */
	public int hashCode() {
		return this.s.hashCode();
	}

	public String toString() {
		return "("+this.s+", "+this.val+")";
	}

	/** Affiche les éléments d'un tableau de type Data[] */
	static void printArray(Data[] T) {
		int l=T.length;
		System.out.print("B=[");
		for(int i=0;i<l;i++)
			System.out.print(" "+T[i]);
		System.out.println(" ]");
	}

}
