
public class Test11 {

	public static void main(String[] args) {
		if (!Test11.class.desiredAssertionStatus()) {
			System.err.println("Vous devez activer l'option -ea de la JVM");
			System.err.println("To run the tests please activate the -ea option of the JVM");
			System.exit(1);
		}

		int n=1000;
		testBruteForce(n);
	}

	public static Data[] largestCities() {
		Data[] result=new Data[16];

		// cities provided with density (km2)
		result[0]=new Data("Osaka", 12111);
		result[1]=new Data("Tokyo", 6169);
		result[2]=new Data("Shangai", 3922);
		result[3]=new Data("Beijing", 1334);
		result[4]=new Data("Jakarta", 15292);
		result[5]=new Data("New York", 11316);
		result[6]=new Data("Los Angeles", 3287);
		result[7]=new Data("Mexico City", 6202);
		result[8]=new Data("Rio de Janeiro", 5350);
		result[9]=new Data("Bogota", 5018);
		result[10]=new Data("Sao Paulo", 8055);
		result[11]=new Data("Buenos Aires", 15046);
		result[12]=new Data("Cairo", 3256);
		result[13]=new Data("Kinshasa", 1713);
		result[14]=new Data("London", 5614);
		result[15]=new Data("Paris", 20460);

		return result;
	}

	public static Data[] increasingArray(int n) {
		Data[] test=new Data[n];
		for(int i=0;i<n;i++)
			test[i]=new Data(""+i, i);
		return test;
	}

	public static Data[] decreasingArray(int n) {
		Data[] test=new Data[n];
		for(int i=0;i<n;i++)
			test[i]=new Data(""+(n-i), n-i);
		return test;
	}

	public static Data[] holeArray(int n) {
		Data[] test=new Data[n];
		for(int i=0;i<n;i++)
			test[i]=new Data("A" + i, 1);
		test[n/3] = new Data("A" + n, 0);
		return test;
	}

	public static void testBruteForce(int n) {
		System.out.println("(Q1.1) Test: RMQ brute-force computation");
		RMQ bruteForce;
		Data[] test=increasingArray(n);
		Data[] cities=largestCities();

		bruteForce=new BruteForceRMQ(cities);
		System.out.print("\tTesting on cities dataset");
		assert (bruteForce.getMin(0, 0).equals(cities[0])): "\n rmq(0, 0): "+"Ville renvoyée: "+bruteForce.getMin(0, 0)+", alors que la densité minimale devrait etre "+cities[0].val;
		assert (bruteForce.getMin(0, 1).equals(cities[1])): "\n rmq(0, 1): "+"Ville renvoyée: "+bruteForce.getMin(0, 1)+", alors que la densité minimale devrait etre "+cities[1].val;
		assert (bruteForce.getMin(14, 15).equals(cities[14])): "\n rmq(14, 15): "+"Ville renvoyée: "+bruteForce.getMin(14, 15)+", alors que la densité minimale devrait etre "+cities[14].val;
		assert (bruteForce.getMin(15, 15).equals(cities[15])): "\n rmq(15, 15): "+"Ville renvoyée: "+bruteForce.getMin(15, 15)+", alors que la densité minimale devrait etre "+cities[15].val;
		assert (bruteForce.getMin(5, 11).equals(cities[6])): "\n rmq(5, 11): "+"Ville renvoyée: "+bruteForce.getMin(5, 11)+", alors que la densité minimale devrait etre "+cities[6].val;
		assert (bruteForce.getMin(12, 13).equals(cities[13])): "\n rmq(12, 13): "+"Ville renvoyée: "+bruteForce.getMin(12, 13)+", alors que la densité minimale devrait etre "+cities[13].val;
		assert (bruteForce.getMin(0, 15).equals(cities[3])): "\n rmq(0, 15): "+"Ville renvoyée: "+bruteForce.getMin(0, 15)+", alors que la densité minimale devrait etre "+cities[3].val;
		System.out.println("\t[OK].");

		System.out.print("\tTesting on increasing array");
		bruteForce=new BruteForceRMQ(test);
		for(int i=0;i<n;i++) {
			for(int j=i;j<n;j++) {
				Data min=bruteForce.getMin(i, j);
				assert (min.val==test[i].val): "\nLa valeur minimale renvoyée est "+min.val+", au lieu de "+test[i].val;
			}
		}
		System.out.println("\t[OK].");

		System.out.print("\tTesting on decreasing array");
		test=decreasingArray(n);
		bruteForce=new BruteForceRMQ(test);
		for(int i=0;i<n;i++) {
			for(int j=i;j<n;j++) {
				Data min=bruteForce.getMin(i, j);
				assert (min.val==test[j].val): "\nLa valeur minimale renvoyée est "+min.val+", au lieu de "+test[j].val;
			}
		}
		System.out.println("\t[OK].");


		System.out.print("\tTesting on single min array");
		test=holeArray(n);
		bruteForce=new BruteForceRMQ(test);
		for(int i=0;i<n;i++) {
			for(int j=i;j<n;j++) {
				Data min=bruteForce.getMin(i, j);
				int ref = i <= n/3 && n/3 <= j ? 0 : 1;
				assert (min.val == ref): "\nLa valeur minimale renvoyée est "+min.val+", au lieu de "+ref;
			}
		}
		System.out.println("\t[OK].");
	}

}
