
public class Test12 {

	public static void main(String[] args) {
		if (!Test12.class.desiredAssertionStatus()) {
			System.err.println("Vous devez activer l'option -ea de la JVM");
			System.err.println("To run the tests please activate the -ea option of the JVM");
			System.exit(1);
		}

		System.out.print("(Q1.2) Test: block decomposition\n");
		Data[] cities=Test11.largestCities();
		EfficientRMQ rmq;

		System.out.print("\tTesting on cities dataset");
		rmq=new EfficientRMQ(cities, 3);
		assert(rmq.getArray()!=null): "\n Le champ 'table' est null";
		assert(rmq.getAuxiliaryArray()!=null): "\n Le tableau auxiliaire n'est pas défini";
		
		Data[] B=rmq.getAuxiliaryArray();
		BruteForceRMQ rmqB=new BruteForceRMQ(B);

		if (B.length != 6)
			System.out.println("Le nombre de blocks de B est: "+B.length+", il devrait etre "+6);
		assert (rmqB.getMin(0, 5).equals(cities[3])): "\n Le résultat est: "+rmqB.getMin(0, 5)+", alors qu'il devrait etre "+cities[3];
		assert (B[0].equals(cities[2])): "\n Le résultat est: "+B[0]+", alors qu'il devrait etre "+cities[2];
		assert (B[1].equals(cities[3])): "\n Le résultat est: "+B[1]+", alors qu'il devrait etre "+cities[3];
		assert (B[2].equals(cities[6])): "\n Le résultat est: "+B[2]+", alors qu'il devrait etre "+cities[6];
		assert (B[3].equals(cities[9])): "\n Le résultat est: "+B[3]+", alors qu'il devrait etre "+cities[9];
		assert (B[4].equals(cities[13])): "\n Le résultat est: "+B[4]+", alors qu'il devrait etre "+cities[13];
		assert (B[5].equals(cities[15])): "\n Le résultat est: "+B[5]+", alors qu'il devrait etre "+cities[15];
		System.out.println("\t\t [OK].");

		System.out.print("\tTesting on increasing array");
		int n=1000;
		Data[] increasing=Test11.increasingArray(n);
		int b=4;
		rmq=new EfficientRMQ(increasing, b);
		B=rmq.getAuxiliaryArray();
		int l=250;
		if (B.length!=l)
			System.out.println("Le nombre de blocks de B est: "+B.length+", il devrait etre "+l);
		assert (B[0].equals(increasing[0])): "\n Le premier block contient: "+B[0]+", alors qu'il devrait contenir "+increasing[0];
		assert (B[l-1].equals(increasing[n-b])): "\n Le dernier block contient: "+B[l-1]+", alors qu'il devrait contenir "+increasing[n-b];
		for(int i=0;i<l-1;i++) {
			assert (B[i].val<B[i+1].val): "\n Erreur: B["+i+"]="+B[i]+", B["+(i+1)+"]="+B[i+1];
		}
		System.out.println("\t\t [OK].");
	}

}
